VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SR2D_Sprite"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Double
  biClrUsed As Double
End Type

Private Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As Long
End Type

Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal dX As Long, ByVal dY As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Private Declare Sub CopyMemory Lib "SR2D" Alias "COPY_MEMORY" (ByRef Dest As Any, ByRef Src As Any, ByVal Length As Long)
Private Declare Sub SClearC Lib "SR2D" Alias "CLEAR_C" (ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WD As Long, ByVal c As Long)
Private Declare Sub SMulAdd Lib "SR2D" Alias "V_MUL_ADD" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal VMUL As Long, ByVal VADD As Long)

Private Declare Sub SOpPaint Lib "SR2D" Alias "PAINT" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpMod2X Lib "SR2D" Alias "MOD_2X" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpAdd2D Lib "SR2D" Alias "ADD_2D" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpAdd Lib "SR2D" Alias "ADD_" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpMod Lib "SR2D" Alias "MOD_" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpAlphaTest Lib "SR2D" Alias "ALPHA_T" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpAlphaBlend Lib "SR2D" Alias "ALPHA_B" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpAlphaCombine Lib "SR2D" Alias "ALPHA_C" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpMoveByte Lib "SR2D" Alias "MOVE_BYTE" (ByVal pSrc As Long, ByVal pDest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long)
Private Declare Sub SOpMoveBit Lib "SR2D" Alias "MOVE_BIT" (ByVal pSrc As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal WS As Long, ByVal WD As Long, ByVal MoveSrc As Long, ByVal MoveDest As Long)

Private Declare Sub SMaskPaint Lib "SR2D" Alias "MASK_PAINT" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskMod2X Lib "SR2D" Alias "MASK_MOD_2X" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskAdd2D Lib "SR2D" Alias "MASK_ADD_2D" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskAdd Lib "SR2D" Alias "MASK_ADD" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskMod Lib "SR2D" Alias "MASK_MOD" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskAlphaTest Lib "SR2D" Alias "MASK_ALPHA_T" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskAlphaBlend Lib "SR2D" Alias "MASK_ALPHA_B" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskAlphaCombine Lib "SR2D" Alias "MASK_ALPHA_C" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskMoveByte Lib "SR2D" Alias "MASK_MOVE_BYTE" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte)
Private Declare Sub SMaskMoveBit Lib "SR2D" Alias "MASK_MOVE_BIT" (ByVal pSrc As Long, ByRef Dest As Long, ByVal pMask As Long, ByVal w As Long, ByVal h As Long, ByVal MaskEx As Long, ByVal WS As Long, ByVal WD As Long, ByVal WM As Long, ByVal NotMask As Byte, ByVal MoveSrc As Long, ByVal MoveDest As Long)

Private Declare Sub SDrawEBM Lib "SR2D" Alias "EBM_" (ByVal pBMap As Long, ByRef Dest As Long, ByVal pLMap As Long, ByVal w As Long, ByVal h As Long, ByVal WB As Long, ByVal WD As Long, ByVal WL As Long, ByVal HL As Long)
Private Declare Sub SDrawEBMEx Lib "SR2D" Alias "EBM_EX" (ByVal pBMap As Long, ByRef Dest As Long, ByVal pLMap As Long, ByVal w As Long, ByVal h As Long, ByVal WB As Long, ByVal WD As Long, ByVal WL As Long, ByVal HL As Long, ByVal XX As Long, ByVal YY As Long, ByVal ADDX As Long, ByVal ADDY As Long)
Private Declare Sub SDrawDPBM Lib "SR2D" Alias "DPBM_" (ByVal pBMap As Long, ByRef Dest As Long, ByVal w As Long, ByVal h As Long, ByVal c As Long, ByVal WS As Long, ByVal WD As Long)

Dim meWidth As Long, meHeight As Long, meOp As SR2D_Op, meDataPTR As Long
Dim meLeft As Long, meRight As Long, meTop As Long, meBottom As Long
Dim cBuf() As Long
Dim bi32BitInfo As BITMAPINFO

Public Sub MulAddS2X(Src As SR2D_Sprite, ByVal dX As Long, ByVal dY As Long, Mul As Long, ByVal Add As Long)
Dim sW As Long, sH As Long, Sp As Long, sX As Long, sY As Long
Dim cX As Long, cY As Long
  sW = Src.Width
  sH = Src.Height

  If dX >= meRight Then Exit Sub
  If dX <= meLeft - sW Then Exit Sub
  If dY >= meBottom Then Exit Sub
  If dY <= meTop - sH Then Exit Sub
  If dX < meLeft Then
    sX = meLeft - dX: cX = sW - sX
    dX = meLeft
  Else
    cX = sW
  End If
  If dY < meTop Then
    sY = meTop - dY: cY = sH - sY
    dY = meTop
  Else
    cY = sH
  End If
  If dX + cX > meRight Then cX = meRight - dX
  If dY + cY > meBottom Then cY = meBottom - dY

  Sp = Src.DataPTR + (sX + (sH - sY - cY) * sW) * 4&
  dY = meHeight - dY - cY

  SMulAdd Sp, cBuf(dX, dY), cX, cY, sW, meWidth, Mul, Add
End Sub

Public Sub DrawDPBM(Src As SR2D_Sprite, ByVal dX As Long, ByVal dY As Long)
Dim sW As Long, sH As Long, Sp As Long, sX As Long, sY As Long
Dim cX As Long, cY As Long
  sW = Src.Width
  sH = Src.Height

  If dX >= meRight Then Exit Sub
  If dX <= meLeft - sW Then Exit Sub
  If dY >= meBottom Then Exit Sub
  If dY <= meTop - sH Then Exit Sub
  If dX < meLeft Then
    sX = meLeft - dX: cX = sW - sX
    dX = meLeft
  Else
    cX = sW
  End If
  If dY < meTop Then
    sY = meTop - dY: cY = sH - sY
    dY = meTop
  Else
    cY = sH
  End If
  If dX + cX > meRight Then cX = meRight - dX
  If dY + cY > meBottom Then cY = meBottom - dY

  Sp = Src.DataPTR + (sX + (sH - sY - cY) * sW) * 4&
  dY = meHeight - dY - cY

  SDrawDPBM Sp, cBuf(dX, dY), cX, cY, ColVLite, sW, meWidth
End Sub

Public Sub DrawEBM(SRCBump As SR2D_Sprite, SRCCol As SR2D_Sprite, ByVal dX As Long, ByVal dY As Long, Optional ByVal DestSpace As Boolean = False)
Dim sW As Long, sH As Long, Sp As Long, sX As Long, sY As Long
Dim cX As Long, cY As Long, ddY As Long
  sW = SRCBump.Width
  sH = SRCBump.Height

  If dX >= meRight Then Exit Sub
  If dX <= meLeft - sW Then Exit Sub
  If dY >= meBottom Then Exit Sub
  If dY <= meTop - sH Then Exit Sub
  If dX < meLeft Then
    sX = meLeft - dX: cX = sW - sX
    dX = meLeft
  Else
    cX = sW
  End If
  If dY < meTop Then
    sY = meTop - dY: cY = sH - sY
    dY = meTop
  Else
    cY = sH
  End If
  If dX + cX > meRight Then cX = meRight - dX
  If dY + cY > meBottom Then cY = meBottom - dY

  Sp = SRCBump.DataPTR + (sX + (sH - sY - cY) * sW) * 4& + 1&
  ddY = meHeight - dY - cY

  If DestSpace Then
    SDrawEBMEx Sp, cBuf(dX, ddY), SRCCol.DataPTR, cX, cY, sW, meWidth, SRCCol.Width, SRCCol.Height, _
    65536! * (dX / meWidth + 0.5!), 65536! * ((meHeight - cY - dY + 1&) / meHeight + 0.5!), _
    65536! / meWidth, 65536! / meHeight
  Else
    SDrawEBM Sp, cBuf(dX, ddY), SRCCol.DataPTR, cX, cY, sW, meWidth, SRCCol.Width, SRCCol.Height
  End If
End Sub

Public Sub DrawMask(Src As SR2D_Sprite, SrcMask As SR2D_Sprite, ByVal dX As Long, ByVal dY As Long, ByVal Mask As Long, Optional ByVal Op As SR2D_Op = -1&, Optional ByVal NotMask As Boolean = False, Optional ByVal mdX As Long, Optional ByVal mdY As Long, Optional ByVal MoveSrc As Long = 0&, Optional ByVal MoveDest As Long = 0&)
Dim sW As Long, sH As Long, Sp As Long, sX As Long, sY As Long
Dim mW As Long, mH As Long, mP As Long, Mx As Long, My As Long
Dim L As Long, r As Long, t As Long, b As Long

  sW = Src.Width
  sH = Src.Height
  mW = SrcMask.Width
  mH = SrcMask.Height
  Mx = dX + mdX
  My = dY + mdY
  sX = dX
  sY = dY

  If sX < Mx Then L = Mx Else L = sX
  If L < meLeft Then L = meLeft

  If sY < My Then t = My Else t = sY
  If t < meTop Then t = meTop

  If sX + sW > Mx + mW Then r = Mx + mW Else r = sX + sW
  If r > meRight Then r = meRight

  If sY + sH > My + mH Then b = My + mH Else b = sY + sH
  If b > meBottom Then b = meBottom
  
  If L >= r Then Exit Sub
  If t >= b Then Exit Sub

  Sp = Src.DataPTR + (L - sX + (sH - b + sY) * sW) * 4&
  mP = SrcMask.DataPTR + (L - Mx + (mH - b + My) * mW) * 4&
  dY = meHeight - b

  If Op = -1& Then Op = Src.Op
  Select Case Op
    Case OpPaint
      SMaskPaint Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpMod2X
      SMaskMod2X Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpAdd2D
      SMaskAdd2D Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpAdd
      SMaskAdd Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpMod
      SMaskMod Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpAlphaTest
      SMaskAlphaTest Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpAlphaBlend
      SMaskAlphaBlend Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpAlphaCombine
      SMaskAlphaCombine Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpMoveByte
      SMaskMoveByte Sp + (MoveSrc And 3&), ByVal VarPtr(cBuf(L, dY)) + (MoveDest And 3&), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask
    Case OpMoveBit
      SMaskMoveBit Sp, cBuf(L, dY), mP, r - L, b - t, Mask, sW, meWidth, mW, -NotMask, MoveSrc, MoveDest
  End Select
End Sub

Public Sub Draw(Src As SR2D_Sprite, ByVal dX As Long, ByVal dY As Long, Optional ByVal Op As SR2D_Op = -1&, Optional ByVal MoveSrc As Long = 0&, Optional ByVal MoveDest As Long = 0&)
Dim sW As Long, sH As Long, Sp As Long, sX As Long, sY As Long
Dim cX As Long, cY As Long
  sW = Src.Width
  sH = Src.Height

  If dX >= meRight Then Exit Sub
  If dX <= meLeft - sW Then Exit Sub
  If dY >= meBottom Then Exit Sub
  If dY <= meTop - sH Then Exit Sub
  If dX < meLeft Then
    sX = meLeft - dX: cX = sW - sX
    dX = meLeft
  Else
    cX = sW
  End If
  If dY < meTop Then
    sY = meTop - dY: cY = sH - sY
    dY = meTop
  Else
    cY = sH
  End If
  If dX + cX > meRight Then cX = meRight - dX
  If dY + cY > meBottom Then cY = meBottom - dY

  Sp = Src.DataPTR + (sX + (sH - sY - cY) * sW) * 4&
  dY = meHeight - dY - cY

  If Op = -1& Then Op = Src.Op
  Select Case Op
    Case OpPaint
      SOpPaint Sp, cBuf(dX, dY), cX, cY, sW, meWidth
    Case OpAlphaTest
      SOpAlphaTest Sp, cBuf(dX, dY), cX, cY, sW, meWidth
    Case OpAlphaBlend
      SOpAlphaBlend Sp, cBuf(dX, dY), cX, cY, sW, meWidth
    Case OpAdd2D
      SOpAdd2D Sp, cBuf(dX, dY), cX, cY, sW, meWidth
    Case OpAdd
      SOpAdd Sp, cBuf(dX, dY), cX, cY, sW, meWidth
    Case OpMod
      SOpMod Sp, cBuf(dX, dY), cX, cY, sW, meWidth
    Case OpMod2X
      SOpMod2X Sp, cBuf(dX, dY), cX, cY, sW, meWidth
    Case OpAlphaCombine
      SOpAlphaCombine Sp, cBuf(dX, dY), cX, cY, sW, meWidth
    Case OpMoveByte
      SOpMoveByte Sp + (MoveSrc And 3&), meDataPTR + (dX + dY * meWidth) * 4& + (MoveDest And 3&), cX, cY, sW, meWidth
    Case OpMoveBit
      SOpMoveBit Sp, cBuf(dX, dY), cX, cY, sW, meWidth, MoveSrc, MoveDest
  End Select
End Sub

Public Sub BlockDraw(Src As SR2D_Sprite, ByVal dX As Long, ByVal dY As Long, ByVal w As Long, ByVal h As Long, Optional ByVal sX As Long = 0&, Optional ByVal sY As Long = 0&, Optional ByVal Op As SR2D_Op = -1&, Optional ByVal MoveSrc As Long = 0&, Optional ByVal MoveDest As Long = 0&)
Dim meL As Long, meR As Long, meT As Long, meB As Long
Dim X As Long, Y As Long, sW As Long, sH As Long
  meL = meLeft
  meR = meRight
  meT = meTop
  meB = meBottom

  Do
    If dX > meLeft Then If dX < meRight Then meLeft = dX Else Exit Do
    If dY > meTop Then If dY < meBottom Then meTop = dY Else Exit Do
    If dX + w <= meLeft Then Exit Do Else If dX + w < meRight Then meRight = dX + w
    If dY + h <= meTop Then Exit Do Else If dY + h < meBottom Then meBottom = dY + h
    sH = Src.Height
    sW = Src.Width
    Do While sX > 0&: sX = sX - sW: Loop
    Do While sY > 0&: sY = sY - sH: Loop
    For Y = dY + sY To meBottom - 1& Step sH
      For X = dX + sX To meRight - 1& Step sW
        Draw Src, X, Y, Op, MoveSrc, MoveDest
      Next X
    Next Y
  Loop While False

  meLeft = meL
  meRight = meR
  meTop = meT
  meBottom = meB
End Sub

Public Sub ClearBuffer(ByVal c As Long)
  SClearC cBuf(meLeft, meHeight - meBottom), meRight - meLeft, meBottom - meTop, meWidth, c
End Sub

Public Sub LoadFromTGA(fName As String, Optional ByVal ColorKey As Long = -1&)
Dim nf As Integer, w As Integer, h As Integer, b As Byte
Dim X As Long, Y As Long, t As Long, d As Long
Dim m() As Byte
  nf = FreeFile
  Open fName For Binary As #nf
    Get #nf, 17&, b
    Select Case b
      Case &H18: t = 3&: meOp = OpPaint
      Case &H20: t = 4&: meOp = OpAlphaBlend
      Case Else: Close #nf: Exit Sub
    End Select
    If ColorKey >= 0& Then meOp = OpAlphaTest
    Get #nf, 13&, w
    Get #nf, 15&, h
    Init w, h, meOp
    ReDim m(w * t - 1&)
    d = &HFF000000
    For Y = 0& To h - 1&
      Get #nf, 19& + w * t * Y, m()
      For X = 0& To w - 1&
        CopyMemory d, m(X * t), t
        If meOp = OpAlphaTest Then
          If (d And &HFFFFFF) = ColorKey Then cBuf(X, Y) = ColorKey Else cBuf(X, Y) = d Or &HFF000000
        Else
          cBuf(X, Y) = d
        End If
      Next X
    Next Y
  Close #nf
End Sub

Public Sub Init(Optional ByVal w As Long = -1&, Optional ByVal h As Long = -1&, Optional ByVal Op As SR2D_Op = -1&)
  If Op <> -1& Then meOp = Op
  If w = -1& And h = -1& Then Exit Sub
  If w <> -1& Then meWidth = w
  If h <> -1& Then meHeight = h
  SetLockRect 0&, w, 0&, h
  ReDim cBuf(meWidth - 1&, meHeight - 1&) As Long
  meDataPTR = VarPtr(cBuf(0&, 0&))
  With bi32BitInfo.bmiHeader
    .biBitCount = 32&
    .biPlanes = 1&
    .biSize = Len(bi32BitInfo.bmiHeader)
    .biWidth = meWidth
    .biHeight = meHeight
    .biSizeImage = 4& * (meWidth * meHeight)
  End With
End Sub

Public Sub SetLockRect(Optional ByVal Left As Long = -1&, Optional ByVal Right As Long = -1&, Optional ByVal Top As Long = -1&, Optional ByVal Bottom As Long = -1&)
  If Left >= 0& And Left < meWidth Then meLeft = Left Else meLeft = 0&
  If Right > Left And Right <= meWidth Then meRight = Right Else meRight = meWidth
  If Top >= 0& And Top < meHeight Then meTop = Top Else meTop = 0&
  If Bottom > Top And Bottom <= meHeight Then meBottom = Bottom Else meBottom = meHeight
End Sub

Public Property Get Width() As Long
  Width = meWidth
End Property

Public Property Get Height() As Long
  Height = meHeight
End Property

Public Property Get Op() As Long
  Op = meOp
End Property

Public Property Get DataPTR() As Long
  DataPTR = meDataPTR
End Property

Public Sub PaintToHDC(ByVal hDC As Long)
  SetDIBitsToDevice hDC, 0&, 0&, meWidth, meHeight, 0&, 0&, 0&, meHeight, cBuf(0&, 0&), bi32BitInfo, 0&
End Sub

Public Sub LoadFromObject(Src As Variant, Optional ByVal ColorKey As Long = -1&)
Dim w As Integer, h As Integer
Dim X As Long, Y As Long
  w = Src.ScaleX(Src.Picture.Width, vbHimetric, vbPixels)
  h = Src.ScaleY(Src.Picture.Height, vbHimetric, vbPixels)
  If ColorKey >= 0& Then Init w, h, OpAlphaTest Else Init w, h, OpPaint
  GetDIBits Src.hDC, Src.Image.Handle, 0&, meHeight, cBuf(0&, 0&), bi32BitInfo, 0&
  If ColorKey >= 0& Then
    For Y = 0& To h - 1&
      For X = 0& To w - 1&
        If (cBuf(X, Y) And &HFFFFFF) = ColorKey Then
          cBuf(X, Y) = ColorKey
        Else
          cBuf(X, Y) = cBuf(X, Y) Or &HFF000000
        End If
      Next X
    Next Y
  Else
    For Y = 0& To h - 1&
      For X = 0& To w - 1&
        cBuf(X, Y) = cBuf(X, Y) Or &HFF000000
      Next X
    Next Y
  End If
End Sub

Public Sub SetPixel(X As Long, Y As Long, c As Long)
  cBuf(X, Y) = c
End Sub

Public Function GetPixel(X As Long, Y As Long) As Long
  GetPixel = cBuf(X, Y)
End Function

Private Sub Class_Initialize()
  Init 1&, 1&, OpPaint
End Sub

Public Sub SaveToTGA(fName As String, Optional ByVal WithAlpha As Boolean = False)
Dim nf As Integer, s As String
Dim X As Long, Y As Long, sLen As Long
  If WithAlpha Then
    sLen = meWidth * 4&
  Else
    sLen = meWidth * 3&
  End If
  ReDim b(sLen - 1&) As Byte
  nf = FreeFile
  Open fName For Binary As #nf: Close #nf: Kill fName
  Open fName For Binary As #nf
    s = TGA_Header(meWidth, meHeight, WithAlpha): Put #nf, , s
    For Y = 0& To meHeight - 1&
      If WithAlpha Then
        CopyMemory b(0&), cBuf(0&, Y), sLen
      Else
        For X = 0& To meWidth - 1&
          CopyMemory b(X * 3&), cBuf(X, Y), 3&
        Next X
      End If
      Put #nf, , b()
    Next Y
    s = TGA_End: Put #nf, , s
  Close #nf
End Sub

Private Function TGA_Header(ByVal w As Long, ByVal h As Long, ByVal WithAlpha As Boolean) As String
Dim Header As String
  Header = String(18&, 0&)
  If WithAlpha Then
    Mid$(Header, 3&, 1&) = Chr$(2&)
    Mid$(Header, 17&, 1&) = Chr$(&H20&)
    Mid$(Header, 18&, 1&) = Chr$(8&)
  Else
    Mid$(Header, 3&, 1&) = Chr$(2&)
    Mid$(Header, 17&, 1&) = Chr$(&H18&)
  End If
  Mid$(Header, 13&, 1&) = Chr$(w And 255&)
  Mid$(Header, 14&, 1&) = Chr$(w \ 256&)
  Mid$(Header, 15&, 1&) = Chr$(h And 255&)
  Mid$(Header, 16&, 1&) = Chr$(h \ 256&)
  TGA_Header = Header
End Function

Private Function TGA_End() As String
  TGA_End = String(8&, 0&) & "TRUEVISION-XFILE." & Chr$(0&)
End Function
