Attribute VB_Name = "modDirShow"
Option Explicit

Private m_objMediaControl As IMediaControl
Private m_objBasicAudio  As IBasicAudio

Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Sub RunAudio(fName As String, ByVal Volume As Single)
Dim meVol As Integer
  meVol = 67 - 67 * Exp((1 - Volume) * 5)
  If meVol < -9999 Then meVol = -9999
  If meVol > 0 Then meVol = 0
  
  Set m_objMediaControl = New FilgraphManager
  Set m_objBasicAudio = m_objMediaControl
  m_objMediaControl.RenderFile fName
  m_objBasicAudio.Volume = meVol
  m_objMediaControl.Run
End Sub

Public Sub DShowStop()
  If Not m_objMediaControl Is Nothing Then
    m_objMediaControl.Stop
    Set m_objBasicAudio = Nothing
    Set m_objMediaControl = Nothing
  End If
End Sub
